Index: c/src/lib/libbsp/powerpc/mpc55xxevb/ChangeLog
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/ChangeLog	(revision 243596d65e9fc5541fc731c8ad7fc3fdc0bcaf9b)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/ChangeLog	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
@@ -1,2 +1,11 @@
+2009-07-20	Sebastian Huber <sebastian.huber@embedded-brains.de>
+
+	* clock/clock-config.c, include/smsc9218i.h, network/smsc9218i.c: New
+	files.
+	* network/network.c: Removed file.
+	* Makefile.am, README, bsp_specs, preinstall.am, include/bsp.h,
+	startup/bspstart.c, startup/sd-card-init.c, tests/tests.c: Changes
+	throughout.
+
 2009-07-16	Joel Sherrill <joel.sherrill@oarcorp.com>
 
Index: c/src/lib/libbsp/powerpc/mpc55xxevb/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/Makefile.am	(revision 243596d65e9fc5541fc731c8ad7fc3fdc0bcaf9b)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/Makefile.am	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
@@ -37,5 +37,8 @@
 include_bsp_HEADERS = include/mpc55xxevb.h \
     include/irq-config.h \
+    include/smsc9218i.h \
     ../../shared/include/irq-generic.h \
+    ../../shared/include/irq-info.h \
+    ../../shared/include/utility.h \
     ../shared/include/tictac.h
 
@@ -46,9 +49,11 @@
 
 # clock
-libbsp_a_SOURCES += ../shared/clock/clock.c
+libbsp_a_SOURCES += clock/clock-config.c
 
 # irq_generic
 libbsp_a_SOURCES += ../../shared/src/irq-generic.c \
-    ../../shared/src/irq-legacy.c
+    ../../shared/src/irq-legacy.c \
+    ../../shared/src/irq-info.c \
+    ../../shared/src/irq-shell.c
 
 # tests
@@ -61,5 +66,5 @@
 if HAS_NETWORKING
 noinst_PROGRAMS += network.rel
-network_rel_SOURCES = network/network.c
+network_rel_SOURCES = network/smsc9218i.c
 network_rel_CPPFLAGS = $(AM_CPPFLAGS) -D__INSIDE_RTEMS_BSD_TCPIP_STACK__ -D__BSD_VISIBLE
 network_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
@@ -74,4 +79,5 @@
     ../../../libcpu/@RTEMS_CPU@/@RTEMS_CPU_MODEL@/irq.rel \
     ../../../libcpu/@RTEMS_CPU@/@RTEMS_CPU_MODEL@/edma.rel \
+    ../../../libcpu/@RTEMS_CPU@/@RTEMS_CPU_MODEL@/emios.rel \
     ../../../libcpu/@RTEMS_CPU@/@RTEMS_CPU_MODEL@/dspi.rel \
     ../../../libcpu/@RTEMS_CPU@/@RTEMS_CPU_MODEL@/esci.rel \
Index: c/src/lib/libbsp/powerpc/mpc55xxevb/README
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/README	(revision 243596d65e9fc5541fc731c8ad7fc3fdc0bcaf9b)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/README	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
@@ -9,5 +9,4 @@
 COPROCESSORS:       N/A
 MODE:               32 bit mode
-DEBUG MONITOR:      BAM
 
 PERIPHERALS
@@ -22,4 +21,5 @@
 SCSI:               N/A
 NETWORKING:         FEC (not yet supported)
+                    SMSC9218I (external)
 SPI:                DSPI
 
@@ -27,5 +27,5 @@
 ==================
 
-CLOCK DRIVER:       Book E decrementer
+CLOCK DRIVER:       EMIOS channel 23
 IOSUPP DRIVER:      N/A
 SHMSUPP:            N/A
@@ -48,5 +48,5 @@
 BUS WIDTH:          32 bit Flash, 32 bit SDRAM
 FLASH:              3 MByte
-RAM:                128 kByte SDRAM 
+INTERNAL RAM:       128 kByte SDRAM 
 EXTERNAL RAM:       512 kByte SDRAM 
 
Index: c/src/lib/libbsp/powerpc/mpc55xxevb/bsp_specs
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/bsp_specs	(revision 243596d65e9fc5541fc731c8ad7fc3fdc0bcaf9b)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/bsp_specs	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
@@ -5,8 +5,8 @@
 *startfile:
 %{!qrtems: %(old_startfile)} \
-%{!nostdlib: %{qrtems: ecrti%O%s rtems_crti%O%s start.o%s}}
+%{!nostdlib: %{qrtems: ecrti%O%s rtems_crti%O%s crtbegin.o%s start.o%s}}
 
 *endfile:
-%{!qrtems: %(old_endfile)} %{qrtems: ecrtn.o%s}
+%{!qrtems: %(old_endfile)} %{qrtems: crtend.o%s ecrtn.o%s}
 
 *link:
Index: c/src/lib/libbsp/powerpc/mpc55xxevb/clock/clock-config.c
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/clock/clock-config.c	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/clock/clock-config.c	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
@@ -0,0 +1,150 @@
+/**
+ * @file
+ *
+ * @ingroup mpc55xx
+ *
+ * @brief Clock driver configuration.
+ */
+
+/*
+ * Copyright (c) 2009
+ * embedded brains GmbH
+ * Obere Lagerstr. 30
+ * D-82178 Puchheim
+ * Germany
+ * <rtems@embedded-brains.de>
+ *
+ * The license and distribution terms for this file may be
+ * found in the file LICENSE in this distribution or at
+ * http://www.rtems.com/license/LICENSE.
+ */
+
+#include <mpc55xx/regs.h>
+#include <mpc55xx/emios.h>
+
+#include <rtems.h>
+
+#include <bsp.h>
+#include <bsp/irq.h>
+
+#define RTEMS_STATUS_CHECKS_USE_PRINTK
+
+#include <rtems/status-checks.h>
+
+#define MPC55XX_CLOCK_EMIOS_CHANNEL (MPC55XX_EMIOS_CHANNEL_NUMBER - 1)
+
+/* This is defined in clockdrv_shell.h */
+rtems_isr Clock_isr( rtems_vector_number vector);
+
+#define Clock_driver_support_at_tick() \
+ do { \
+    union EMIOS_CSR_tag csr = MPC55XX_ZERO_FLAGS; \
+    csr.B.FLAG = 1; \
+    EMIOS.CH [MPC55XX_CLOCK_EMIOS_CHANNEL].CSR.R = csr.R; \
+ } while (0)
+
+static void mpc55xx_clock_handler_install( void)
+{
+  rtems_status_code sc = RTEMS_SUCCESSFUL;
+
+  sc = mpc55xx_interrupt_handler_install(
+    MPC55XX_IRQ_EMIOS_GET_REQUEST( MPC55XX_CLOCK_EMIOS_CHANNEL),
+    "clock",
+    RTEMS_INTERRUPT_UNIQUE,
+    MPC55XX_INTC_MIN_PRIORITY,
+    (rtems_interrupt_handler) Clock_isr,
+    NULL
+  );
+  RTEMS_CHECK_SC_VOID( sc, "install clock interrupt handler");
+}
+
+static void mpc55xx_clock_initialize( void)
+{
+  volatile struct EMIOS_CH_tag *regs = &EMIOS.CH [MPC55XX_CLOCK_EMIOS_CHANNEL];
+  union EMIOS_CCR_tag ccr = MPC55XX_ZERO_FLAGS;
+  union EMIOS_CSR_tag csr = MPC55XX_ZERO_FLAGS;
+  unsigned prescaler = mpc55xx_emios_global_prescaler();
+  uint64_t interval = ((uint64_t) bsp_clock_speed
+    * (uint64_t) rtems_configuration_get_microseconds_per_tick()) / 1000000;
+
+  /* Apply prescaler */
+  if (prescaler > 0) {
+    interval /= (uint64_t) prescaler;
+  } else {
+    RTEMS_SYSLOG_ERROR( "unexpected global eMIOS prescaler\n");
+  }
+
+  /* Check interval */
+  if (interval == 0 || interval > MPC55XX_EMIOS_VALUE_MAX) {
+    interval = MPC55XX_EMIOS_VALUE_MAX;
+    RTEMS_SYSLOG_ERROR( "clock timer interval out of range\n");
+  }
+
+  /* Configure eMIOS channel */
+  
+  /* Set channel in GPIO mode */
+  ccr.B.MODE = MPC55XX_EMIOS_MODE_GPIO_INPUT;
+  regs->CCR.R = ccr.R;
+  
+  /* Clear status flags */
+  csr.B.OVR = 1;
+  csr.B.OVFL = 1;
+  csr.B.FLAG = 1;
+  regs->CSR.R = csr.R;
+  
+  /* Set timer period */
+  regs->CADR.R = (uint32_t) interval - 1;
+  
+  /* Set unused registers */
+  regs->CBDR.R = 0;
+  regs->CCNTR.R = 0;
+  regs->ALTCADR.R = 0;
+  
+  /* Set control register */
+  ccr.B.MODE = MPC55XX_EMIOS_MODE_MC_UP_INT_CLK;
+  ccr.B.UCPREN = 1;
+  ccr.B.FEN = 1;
+  ccr.B.FREN = 1;
+  regs->CCR.R = ccr.R;
+}
+
+static void mpc55xx_clock_cleanup( void)
+{
+  rtems_status_code sc = RTEMS_SUCCESSFUL;
+  volatile struct EMIOS_CH_tag *regs = &EMIOS.CH [MPC55XX_CLOCK_EMIOS_CHANNEL];
+  union EMIOS_CCR_tag ccr = MPC55XX_ZERO_FLAGS;
+
+  /* Set channel in GPIO mode */
+  ccr.B.MODE = MPC55XX_EMIOS_MODE_GPIO_INPUT;
+  regs->CCR.R = ccr.R;
+
+  /* Remove interrupt handler */
+  sc = rtems_interrupt_handler_remove(
+    MPC55XX_IRQ_EMIOS_GET_REQUEST( MPC55XX_CLOCK_EMIOS_CHANNEL),
+    (rtems_interrupt_handler) Clock_isr,
+    NULL
+  );
+  RTEMS_CHECK_SC_VOID( sc, "remove clock interrupt handler");
+}
+
+static uint32_t mpc55xx_clock_nanoseconds_since_last_tick( void)
+{
+  uint64_t clicks = EMIOS.CH [MPC55XX_CLOCK_EMIOS_CHANNEL].CCNTR.R;
+  uint64_t clock = bsp_clock_speed;
+  uint64_t ns = (clicks * 1000000000) / clock;
+  
+  return (uint32_t) ns;
+}
+ 
+#define Clock_driver_support_initialize_hardware() mpc55xx_clock_initialize()
+
+#define Clock_driver_support_install_isr( isr, old_isr) \
+  mpc55xx_clock_handler_install()
+
+#define Clock_driver_support_shutdown_hardware() mpc55xx_clock_cleanup()
+  
+#define Clock_driver_nanoseconds_since_last_tick \
+  mpc55xx_clock_nanoseconds_since_last_tick
+
+/* Include shared source clock driver code */
+#include "../../../../libbsp/shared/clockdrv_shell.h"
Index: c/src/lib/libbsp/powerpc/mpc55xxevb/include/bsp.h
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/include/bsp.h	(revision 243596d65e9fc5541fc731c8ad7fc3fdc0bcaf9b)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/include/bsp.h	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
@@ -44,5 +44,18 @@
 extern uint32_t bsp_clicks_per_usec;
 
-rtems_status_code mpc55xx_sd_card_init( void);
+rtems_status_code mpc55xx_sd_card_init( bool mount);
+
+/* Network driver configuration */
+
+struct rtems_bsdnet_ifconfig;
+
+int smsc9218i_attach_detach(
+  struct rtems_bsdnet_ifconfig *config,
+  int attaching
+);
+
+#define RTEMS_BSP_NETWORK_DRIVER_ATTACH smsc9218i_attach_detach
+
+#define RTEMS_BSP_NETWORK_DRIVER_NAME "eth0"
 
 #endif /* ASM */
